unit MBM5;

interface

uses Classes, Windows, MBM5Types;

type
  TMBM5SM = class(TComponent)
  private
    fSharedData : TSharedData;
    fSharedInfo : TSharedInfo;
    fSharedHL   : TSharedHL;
    fSharedName : TSharedName;
    function ReadSharedData : Boolean;
    function ReadSharedInfo : Boolean;
    function ReadSharedHL : Boolean;
    function ReadSharedName : Boolean;
  protected
    { Protected-Deklarationen }
  public
    function ReadShareMem: Boolean;
  published
    property SharedData : TSharedData read fSharedData;
    property SharedInfo : TSharedInfo read fSharedInfo;
    property SharedHL   : TSharedHL   read fSharedHL;
    property SharedName : TSharedName read fSharedName;
  end;

procedure Register;

implementation

function TMBM5SM.ReadSharedData : Boolean;
var
  PSH          : PSharedData;
  hSData       : Integer;
begin
  Result:=False;

  hSData:=OpenFileMapping(FILE_MAP_READ, False, '$M$B$M$5$D$');

  if hSData=0 then Exit;

  PSH:=MapViewOfFile(hSData, FILE_MAP_READ, 0, 0, 0);

  if PSH=Nil then
  begin
    CloseHandle(hSData);
    Exit;
  end;
  fSharedData := PSH^;

  UnMapViewOfFile(PSH);
  CloseHandle(hSData);
  Result:=True;
end;

function TMBM5SM.ReadSharedInfo : Boolean;
var
  PSH          : PSharedInfo;
  hSInfo       : Integer;
begin
  Result:=False;

  hSInfo:=OpenFileMapping(FILE_MAP_READ, False, '$M$B$M$5$I$');

  if hSInfo=0 then Exit;

  PSH:=MapViewOfFile(hSInfo, FILE_MAP_READ, 0, 0, 0);

  if PSH=Nil then
  begin
    CloseHandle(hSInfo);
    Exit;
  end;

  fSharedInfo := PSH^;
  UnMapViewOfFile(PSH);
  CloseHandle(hSInfo);
  Result:=True;
end;

function TMBM5SM.ReadSharedHL : Boolean;
var
  PSH          : PSharedHL;
  hSHL         : Integer;
begin
  Result:=False;

  hSHL:=OpenFileMapping(FILE_MAP_READ, False, '$M$B$M$5$H$');

  if hSHL =0 then Exit;

  PSH:=MapViewOfFile(hSHL, FILE_MAP_READ, 0, 0, 0);

  if PSH=Nil then
  begin
    CloseHandle(hSHL);
    Exit;
  end;
  fSharedHL := PSH^;
  UnMapViewOfFile(PSH);
  CloseHandle(hSHL);
  Result:=True;
end;

function TMBM5SM.ReadSharedName : Boolean;
var
  PSH          : PSharedName;
  hSData       : Integer;
begin
  Result:=False;

  hSData:=OpenFileMapping(FILE_MAP_READ, False, '$M$B$M$5$N$');

  if hSData=0 then Exit;

  PSH:=MapViewOfFile(hSData, FILE_MAP_READ, 0, 0, 0);

  if PSH=Nil then
  begin
    CloseHandle(hSData);
    Exit;
  end;

  fSharedName := PSH^;
  UnMapViewOfFile(PSH);
  CloseHandle(hSData);
  Result:=True;
end;

procedure Register;
begin
  RegisterComponents('Beispiele', [TMBM5SM]);
end;

function TMBM5SM.ReadShareMem: Boolean;
begin
  Result := ReadSharedData;
  Result := Result and ReadSharedInfo;
  Result := Result and ReadSharedHL;
  Result := Result and ReadSharedName;
end;

end.
