unit fmMainform;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, inifiles, Menus,
  CoolTrayIcon, PollinLCD, ExFont, expr, PollinLCDPreview, ComCtrls;

const
  MaxAnzeigen = 100;
  MaxZeilen = 8;
  MaxDrawLines = 20;
  IniFile = 'display.ini';
  Version = '0.6';

type
  TForm1 = class(TForm)
    T_UpdateTimer: TTimer;
    PM_TrayMenue: TPopupMenu;
    Beenden1: TMenuItem;
    T_NextScreenTimer: TTimer;
    CTI_TrayIcon: TCoolTrayIcon;
    Image1: TImage;
    PL_LCD: TPollinLCD;
    PLP_Preview: TPollinLCDPreview;
    M_MainMenu: TMainMenu;
    Schliessen1: TMenuItem;
    Vorschau1: TMenuItem;
    SB_1: TStatusBar;
    N1: TMenuItem;
    Vorschau2: TMenuItem;
    procedure T_UpdateTimerTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Beenden1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure T_NextScreenTimerTimer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Vorschau1Click(Sender: TObject);
    procedure Schliessen1Click(Sender: TObject);
    procedure Vorschau2Click(Sender: TObject);
    procedure FormHide(Sender: TObject);
  private
    ExprCalc: TExprCalc;
    Ini: TInifile;
    Screens: record
        Count: Integer;
        ActualScreen: Integer;
        Fontname: String;
        FontSize: Integer;
        TextLines: array [1..MaxAnzeigen, 1..MaxZeilen] of String;
        DrawLines: array [1..MaxAnzeigen, 1..MaxDrawLines] of String;
        Intervals: array[1..MaxAnzeigen] of Integer;
        GraficFilenames: array [1..MaxAnzeigen] of String;
        GraficModes: array [1..MaxAnzeigen] of Integer;
    end;
    LinesDrawn: Boolean;  // Gibt an ob Linien gezeichnet wurden die evtl.
                          //gelscht werden sollten
    procedure DrawBitmap(IndexAnzeige: Integer);
    procedure DrawLines(IndexAnzeige: Integer; IsBlack: Boolean);
    procedure DrawText(IndexAnzeige: Integer);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses uVars;

procedure TForm1.FormCreate(Sender: TObject);
var
  i, j: Integer; Fnt: TFont;
begin
  ExprCalc := TExprCalc.Create(nil);

  ini := TInifile.create(IncludeTrailingBackslash(ExtractFilePath(Application.exename))+IniFile);
  T_UpdateTimer.Interval := ini.ReadInteger('Einstellungen', 'Aktualisierungsinterval', 1)*1000;
  with PL_LCD do
  begin
        printerport := Ini.ReadInteger('Einstellungen','Schnittstellenadresse',$378);
        Bidirectional := Ini.ReadBool('Einstellungen', 'Bidirektional', False);

        Active := True;

        if Ini.ReadBool('Einstellungen','EigenerSchriftsatz', False) then
        begin
            LoadExFont(printerport, Bidirectional);
            ExternalFont := True;
        end;

        //externen Schriftfont aus der INI laden
        fnt := Tfont.Create;
        fnt.Name := Ini.ReadString('Einstellungen','Fontname','');
        fnt.Size := Ini.ReadInteger('Einstellungen','Fontgrsse',0);
        if (fnt.Size > 0) and (fnt.Name <> '') then
                Font := fnt;     //externen Schriftsatz verwenden
        fnt.free;
        EnabledGraphic := True;
        EnabledText := True;
        Clear;
  end;

  //Screens aus der INI holen
  Screens.Count := 0;
  Screens.ActualScreen := 0;
  for i := 1 to MaxAnzeigen do
        if ini.SectionExists('Anzeige' + IntToStr(i)) then
        begin
                Inc(Screens.Count);
                Screens.Intervals[i] := ini.ReadInteger('Anzeige' + IntToStr(i), 'Dauer', 1);
                for j := 1 to MaxZeilen do
                        Screens.TextLines[i, j] := ini.ReadString('Anzeige' + IntToStr(i), 'Zeile'+ IntToStr(j), '');
                Screens.GraficFilenames[i] := ini.ReadString('Anzeige' + IntToStr(i), 'Bilddatei', '');
                Screens.GraficModes[i] := ini.ReadInteger('Anzeige' + IntToStr(i), 'Mode', 1)-1;
                for j := 1 to MaxDrawLines do
                        Screens.DrawLines[i, j] := ini.ReadString('Anzeige' + IntToStr(i), 'Strich'+ IntToStr(j), '');
        end
        else
           Break;
  if Screens.Count > 0 then
  begin
        Screens.ActualScreen := 1;
        T_NextScreenTimer.Interval := Screens.Intervals[1]*1000;
        T_NextScreenTimer.Enabled := True;
  end;
  ini.free;

  SB_1.Panels[0].Text := Format('Gesamt: %d',[Screens.Count]);
  Form1.Caption := 'PollinLCD - ' + version;

  //Erstes Mal Ausgabe auf dem Display
  T_UpdateTimerTimer(nil);
  DrawBitmap(Screens.ActualScreen);
end;

//Variablen bezeichner durch Werte ersetzen

procedure TForm1.T_UpdateTimerTimer(Sender: TObject);
begin
  if Screens.ActualScreen > 0 then
  begin
        PL_LCD.BeginUpdate;
        if Linesdrawn then DrawLines(Screens.ActualScreen, false);  //Alte Linien lschen
        CollectValues;     //Daten aller Variablen ermitteln
        DrawText(Screens.ActualScreen);
        DrawLines(Screens.ActualScreen, true);
        PL_LCD.cc := 0; //Counter fr geschriebene Bytes auf 0 setzen
        PL_LCD.c := 0;
        PL_LCD.dc := 0;

        PL_LCD.EndUpdate;

        SB_1.Panels[1].Text := Format('Aktuell: %d',[Screens.ActualScreen]);
        SB_1.Panels[2].Text := Format('%dByte(s) gendert - Data: %dByte, Ctrl: %dByte',[PL_LCD.c, PL_LCD.dc,PL_LCD.cc]);
  end;
end;

procedure TForm1.T_NextScreenTimerTimer(Sender: TObject);
begin
  T_Updatetimer.Enabled := False;
  with Screens do
  begin
        Inc(ActualScreen);                                      //nchster Screen
        if  ActualScreen > Count then ActualScreen := 1;        //wenn am Ende dann wieder den ersten nehmen
        T_NextScreenTimer.Interval := Intervals[ActualScreen]*1000;        //Timerinterval neu setzen
        DrawBitmap(Screens.ActualScreen);                       //Bitmap nur einmal am Anfang zeichnen
        LinesDrawn := False; //Neuer Screen, deswegen keine Linien gezeichnet
        T_UpdateTimerTimer(nil);                                       //Anzeigen
  end;
  T_Updatetimer.Enabled := True;
end;

procedure TForm1.Beenden1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  T_UpdateTimer.Enabled := False;      //Timer1 aus damit er die Ausgabe nicht berschreibt
  PL_LCD.DisplayMode := 0;
  PL_LCD.EnabledGraphic := true;
  PL_LCD.Clear;
  PL_LCD.Text :=  '                                        '+
                     '                                        '+
                     '                                        '+
                     '                                        '+
                     '                                        '+
                     '                                        '+
                     '                                    v'+version+
                     '                      MaikRutsche@gmx.de';
  PL_LCD.DrawBmp(0, 23, Image1.Picture.Bitmap);
end;

procedure TForm1.DrawText(IndexAnzeige: Integer);
var
  i: Integer;
  Line, DisplayText: String;
begin
  DisplayText := '';
  for i := 1 to MaxZeilen do                 //Alle 8 Zeilen bearbeiten
  begin
       line := Screens.TextLines[Screens.ActualScreen, i];  //Zeile die bearbeitet werden soll
       Line := DekodiereZeile(Line, 40);
       DisplayText := DisplayText + Line;
  end;
  PL_LCD.Text := DisplayText; //Anzeige setzen
end;

procedure TForm1.DrawBitmap(IndexAnzeige: Integer);
var
  Bmp: TBitmap;
  Filename: TFilename;
begin
  Filename := Screens.GraficFilenames[IndexAnzeige];

  if not FileExists(Filename) then
  begin
        PL_LCD.EnabledGraphic := False;
        Exit;
  end;
  bmp := TBitmap.Create;
  try
    try
      bmp.LoadFromFile(Filename);
      PL_LCD.DrawBmp(0, 0, Bmp);
      PL_LCD.DisplayMode := Screens.GraficModes[IndexAnzeige];
      PL_LCD.EnabledGraphic := true;
    except
      PL_LCD.EnabledGraphic := False;
    end;
  finally
    Bmp.Free;
  end;
end;

procedure TForm1.DrawLines(IndexAnzeige: Integer; IsBlack: Boolean);
var
  S, sxy: String;
  i, x1, x2, y1, y2: Integer;
begin
  for i := 1 to MaxDrawLines do
  begin
      s := Screens.DrawLines[IndexAnzeige, i];
      if S <> '' then
      begin
           s := DekodiereZeile(s, 0);

           sxy := Copy(s, 1, Pos('|', S)-1);
           s := Copy (S, Pos ('|', S)+1, Length(s) - Pos('|', s)+1);
           x1 := Trunc(ExprCalc.DoExpr(sxy));

           sxy := Copy(s, 1, Pos('|', S)-1);
           s := Copy (S, Pos ('|', S)+1, Length(s) - Pos('|', s)+1);
           y1 := Trunc(ExprCalc.DoExpr(sxy));

           sxy := Copy(s, 1, Pos('|', S)-1);
           s := Copy (S, Pos ('|', S)+1, Length(s) - Pos('|', s)+1);
           x2 := Trunc(ExprCalc.DoExpr(sxy));
           y2 := Trunc(ExprCalc.DoExpr(s));

           PL_LCD.DrawLine(x1, y1, x2, y2, IsBlack);
           LinesDrawn := true;
      end;
  end;
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
   showMessage(IntToStr(win32platform));
end;

procedure TForm1.Vorschau1Click(Sender: TObject);
begin
  if Vorschau1.Tag = 0 then
  begin
        Vorschau1.Caption := 'Vorschau aus';
        Vorschau1.Tag := 1;
        PLP_Preview.Enabled := true;
        PLP_Preview.DrawPreview;
  end
  else
  begin
        Vorschau1.Caption := 'Vorschau ein';
        Vorschau1.Tag := 0;
        PLP_Preview.Enabled := false;
  end;
end;

procedure TForm1.Schliessen1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Vorschau2Click(Sender: TObject);
begin
  Form1.Show;
  Vorschau1.Tag := 0;
  Vorschau1Click(nil);
end;

procedure TForm1.FormHide(Sender: TObject);
begin
  Vorschau1.Tag := 1;
  Vorschau1Click(nil);
end;

end.
